---
name: Feature request
about: Suggest an idea for a new feature
title: ''
labels: 'enhancement, awaiting-triage'
assignees: ''

---

## Feature Request

### Problem
A clear and concise description how this idea has manifested and the context. Elaborate on the need for this feature and/or what could be improved. Ex. I'm always frustrated when [...]

### Requirements
A clear and concise description of the requirements to satisfy the new feature. Detail what you expect from a successful implementation of the feature. Ex. When using this feature, it should [...]

### Justification
Provide the key benefits in making this a supported feature. Ex. Adding support for this feature would ensure [...]

### Alternative Considerations
Do you currently have a work-around for this? Provide any alternative solutions or features you've considered.

### Related Errors
Add any errors as a direct result of not exposing this feature.

Please include steps to reproduce provided errors as follows:
- OS (WIN | MACOS | Linux)
- Python Version OR MATLAB Version
- MySQL Version
- MySQL Deployment Strategy (local-native | local-docker | remote)
- DataJoint Version
- Minimum number of steps to reliably reproduce the issue
- Complete error stack as a result of evaluating the above steps

### Screenshots
If applicable, add screenshots to help explain your feature.

### Additional Research and Context
Add any additional research or context that was conducted in creating this feature request.

For example:
- Related GitHub issues and PR's either within this repository or in other relevant repositories.
- Specific links to specific line or focus within source code.
- Relevant summary of Maintainers development meetings, milestones, projects, etc.
- Any additional supplemental web references or links that would further justify this feature request.
